#pragma once

#include "..\..\DuiLib\UIlib.h"

using namespace DuiLib;

#define MB_SAVECLOSE              0x00000007L	//   ݱ, ݱ
#define MAX_MESSAGEBOX_COUNT	  10

class CDuiMessageBox : public WindowImplBase
{
	DUI_DECLARE_MESSAGE_MAP()

public:
	CDuiMessageBox(CWnd* pParent);
	CDuiMessageBox(HWND hParentWnd);
	~CDuiMessageBox();
	
	void CreateMessageBox(HWND hParentWnd);
	void Init(LPCTSTR pszText, LPCTSTR pszCaption, UINT uType, BOOL bShowCheck = FALSE, LPCTSTR pszCheckMsg = _T(""), LPCTSTR pszCheckID = _T(""), 
		BOOL bForceWindowTop = FALSE, LPCTSTR pszYes = _T(""), LPCTSTR pszNo = _T(""));
	LPCTSTR GetWindowClassName() const;
	void OnPrepare(TNotifyUI& msg);
	void ClickButton(int nButtonIndex);
	void SetButtonText();

	virtual CDuiString GetSkinFile();
	virtual CDuiString GetSkinFolder();
	virtual void OnFinalMessage(HWND hWnd);
	virtual LRESULT OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	virtual LRESULT OnMouseMove(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled);
	virtual LRESULT OnLButtonDown(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled);
	virtual LRESULT OnLButtonUp(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled);

protected:
	void NotifyCtrlClick(TNotifyUI& msg);
	void OnNotifySetFocus(TNotifyUI& msg);
	void OnNotifyKillFocus(TNotifyUI& msg);
	// DUI member
private:

private:
	BOOL		m_bClosing;
	CString		m_strCaption;
	CString		m_strText;

	UINT		m_uType;
	CPen		m_penBorder;
	BOOL		m_bShowCheck;		
	CString		m_strCheckMsg;		
	CString		m_strCheckID;		
	BOOL		m_bForceWindowTop;	

	CString		m_strYes;
	CString		m_strNo;

};

////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*!
 * @brief      ޽ ڽ
 * @return    int (DoModal ϰ)
 * @param     CWnd *pParent, LPCTSTR pszText, LPCTSTR pszCaption = _T("Ntalk biz"), UINT nType = MB_OK
 * @author    Jinwoo.Lee(jinwoo.lee@nhn.com)
 * @date      2012-04-05 
 * @warning   ޽ 뿡  ȭ ũⰡ (ּ  290*150)
 */
extern int g_ModalBoxCount;
extern int g_nMessageBoxCount;
extern HWND g_hMessageBox[MAX_MESSAGEBOX_COUNT];
extern CCriticalSection g_csModalBoxCount;


int NMessageBox(CWnd *pParent, LPCTSTR pszText, LPCTSTR pszCaption = _T("Ntalk biz"), UINT nType = MB_OK, BOOL bShowCheck = FALSE, LPCTSTR pszCheckMsg = _T(""), LPCTSTR pszCheckID = _T(""), 
					   BOOL bForeceTopWindow = FALSE, LPCTSTR pszYes = _T(""), LPCTSTR pszNo = _T(""));

int NMessageBoxEx(HWND hwndParentWindow, LPCTSTR pszText, LPCTSTR pszCaption = _T("Ntalk biz"), UINT nType = MB_OK, BOOL bShowCheck = FALSE, LPCTSTR pszCheckMsg = _T(""), LPCTSTR pszCheckID = _T(""), 
					   BOOL bForeceTopWindow = FALSE, LPCTSTR pszYes = _T(""), LPCTSTR pszNo = _T(""));
